//******       ,    *****
/*     2 ,   32768  .   128
1        OCR2
EEPROM  
-------------------------------------------------------------------------
   |     100       |     245    |    200   |     0    |     0   |
 ------------------------------------------------------------------------
   |     shst      | I_kof     |    U_kof |      emcost         |
-------------------------------------------------------------------------

*/
#define F_CPU 8000000UL // 8Mhz
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include "lcd_lib.h"
long int emkost;
unsigned int voltage,voltage_in, current,current_in, adc_counter;            //     -  
volatile unsigned long voltage_value, current_value;
unsigned int  k=0, Uoff=100 ;              //    
EEMEM unsigned int eeprom_emcost  ;
EEMEM unsigned char eeprom_U_kof  ;
EEMEM unsigned char eeprom_I_kof  ;
EEMEM unsigned char eeprom_shst  ;//    
unsigned char t=0, min=0 , clock=0 ,  flag=0 ,  flag_zar=0, shima=0 ,j=0 , f=0,flag_zar_in=0;
unsigned char shst; //    
#define shima_start shst
#define shima_end 32
unsigned char U_kof,I_kof;

void save (void)
{
	eeprom_write_byte(&eeprom_U_kof,U_kof);
	eeprom_write_byte(&eeprom_I_kof,I_kof);
	
}
ISR(ADC_vect)//    
{
	ADCSRA = 0; //  
	if((ADMUX & 0x0F)==1) //     ADC1
	{
		voltage_value = voltage_value + ADC; //        
		ADMUX = (ADMUX & 0xF0) | 0; //   ADC0
	}
	else
	{
		current_value = current_value + ADC; //        
		ADMUX = (ADMUX & 0xF0) | 1; //   ADC1
		adc_counter++; //      1
	}
	//  
	ADCSRA |= (1 << ADEN)|(1 << ADSC)|(1 << ADPS2)|(1 << ADPS1)|(1 << ADPS0)|(1 << ADIE);
}
ISR(TIMER2_COMP_vect)// ==========   TIMER2 (1 )
{
	if ((flag==1)||(flag_zar==1)){t++;}
}
void Tip_Ak(void) //--    Li-ion  Ni-Mg
{
	lcd_gotoxy(0, 0);
	if (voltage >200){lcd_string("Lion ",5);Uoff = 290;}  //    Li-ion  2,8 
	else {lcd_string("NiMg ",5);Uoff = 100;}			//    Ni-Mg  1 
}
void shima_set(void)
{	
	sh:
	lcd_gotoxy(0, 0);
	lcd_string("3AP TOK ",8);
	switch(shst)
	{
		case 50: lcd_string(" 235 mA ",8);break;
		case 75: lcd_string(" 365 mA ",8);break;
		case 100: lcd_string(" 470 mA ",8);break;
		case 125: lcd_string(" 615 mA ",8);break;
		case 150: lcd_string(" 745 mA ",8);break;
		case 175: lcd_string(" 840 mA ",8);break;
		case 200: lcd_string(" 990 mA ",8);break;
		case 225: lcd_string("1120 mA ",8);break;
		default:lcd_gotoxy(0, 1);
	}
	lcd_gotoxy(0, 1);_delay_ms(200);
	lcd_string("S MAX=",6);lcd_num_to_str(shst, 3);lcd_string(" KH Z,T",7);
			if ((PINC &(1<<PC2))==0)   //    ZAR
					{	shst=shst+25;_delay_ms(140);
						if (shst>225){ shst=50;}
									
					}
			if ((PINB &(1<<PB0))==0) //    TEST   
					{
						eeprom_write_byte(&eeprom_shst,shst);
						return;
					}
	
	
	goto sh;
}
void start (void)
{
	lcd_gotoxy(0, 0);          //       0  ,1   ( 16  (0-15)
	lcd_string("---_ U-.-- A.---",16);
	lcd_gotoxy(0, 1);                           //       0  ,2   ( 16  (0-15)
	lcd_string("----mA/c -:--:--",16);
}
void LCD_Time (void)
{
	
	if (t==60)
	{	min++;t=0; 							 //    1
		if (min==60)
		{
			min=0;
			clock++;
		}
		
		if (flag==1)					//        
		{
			emkost=emkost +	current;
			lcd_gotoxy(0, 1);
			lcd_num_to_str(emkost/60, 4);
		}
		
	}
	lcd_gotoxy(14, 1);
	lcd_num_to_str(t, 2);
	lcd_gotoxy(8, 1);
	lcd_num_to_str(clock, 2);
	lcd_gotoxy(11, 1);
	lcd_num_to_str(min, 2);
}

void ZAR_REG (void)//     i 255-0
{
	_delay_ms(10);
	
	if (flag_zar==1) // ********************* 
	{
		TCCR1A |= (1 << COM1A1)|(0 << COM1A0)|(1 << WGM11)|(0 << WGM10);
		TCCR1B |= (1 << WGM13)|(1 << WGM12)|(1 << CS12)|(0 << CS11)|(0 << CS10);
		
							if (flag_zar_in==0) //   
							{ shima=shima+1;}
							_delay_ms(10);	
								if ((voltage >= 422 )&&(flag_zar_in==0)) //   
								{flag_zar_in=1;}
							_delay_ms(10);
							if (shima>shima_start)  //   
							{flag_zar_in=1;	}
							
							_delay_ms(10);
							if ((voltage >= 422 )&&(flag_zar_in==1)) //   
							{	shima=shima-2;}
								
							if ((shima<shima_end)&&(flag_zar_in==1)) //  
							{ flag_zar=0;PORTC &= ~(1<<PC3);} // off  
			
							
	OCR1A = shima;
	
	}
	
	
	if (flag_zar==0) // ******************* 
	{
		OCR1A=0;shima=0;flag_zar_in=0;
		TCCR1A = 0;
		TCCR1B =0;
		
	}
}
//********************************************************


int main(void)
{
	DDRC |=(1<<PC4);  //    PC4 - MOSFET  
	DDRB |=(1<<PB1);  //    PB1 - MOSFET     R 1.8 Om 
	PORTB &= ~(1<<PB1);  //  0
	DDRB &=~(1<<PB0);  //    PB0 -      
	DDRC &=~(1<<PC2);  //    PC2 -     
	PORTB |=(1<<PB0);   //  PB0
	PORTC |=(1<<PC2);   //  PC2
	DDRC |=(1<<PC3); //    PC3 - */ 
	PORTC |=(1<<PC3); //  
	shima=0;
	
	
	
								//****************  ,  pb4+   pb5-     koff
								DDRB |=(0<<PB4)|(0<<PB5);  //   -  
								PORTB |=(1<<PB4)|(1<<PB5);//
								U_kof=eeprom_read_byte(&eeprom_U_kof);
								I_kof=eeprom_read_byte(&eeprom_I_kof);
								// *****************
								// *****************   
								shst=eeprom_read_byte(&eeprom_shst);
								if ((shst>230)||(shst<50))  //     225- 50
								{shst=100;}
								
								
								
								// *****************
	
		ADMUX |= (1 << REFS1)|(1 << REFS0); //   2,56V
		ADMUX |= (1 << MUX0); //   ADC1
		_delay_us(10); 
		ADCSRA |= (1 << ADEN) //  
		|(1 << ADSC) //  
		|(1 << ADPS2)|(1 << ADPS1)|(1 << ADPS0) //   128 (62.5Khz)    8 
		|(1 << ADIE); //    
		
	////     	1 -  *******************************************************
						
									TCCR1A |= (1 << WGM11)|(0 << WGM10); //   COM1A1-COM1A0:0b10,     A  
									 //   WGM13-10:0b1110,     (  )
									TCCR1B |= (1 << WGM13)|(1 << WGM12) //   - FAST PWM,       ICR1
									|(1 << CS12)|(0 << CS11)|(0 << CS10); //  CS12-10:0b001       ,   8
									TCNT1 = 0x00; //   
									ICR1 = 0xFF; //   ,     255,
									//   fPWM=fclk_I/O/8(1+ICR1)//   ,    3906 Hz
									//OCR1A = 0xFF; //    

		//     	2 1  *******************************************************
						ASSR|=(1<<AS2); //   
						TCCR2 |= (1<<WGM21) //    OCR2
						|(1 << CS22)|(0 << CS21)|(1 << CS20); //32768/128=256 Hz    
						OCR2 = 255;//     
						TIMSK |=(1<<OCIE2) ;//     OCR2
						sei(); //    (  I    SREG) 

		lcd_init(); //  LCD
		lcd_clr();//  LCD
		_delay_ms(25);
		
		lcd_gotoxy(0, 0);          //       0  ,1   ( 16  (0-15)
		lcd_string("OLD C ",6);
		unsigned int temp;
		temp=eeprom_read_word(&eeprom_emcost);
		lcd_num_to_str(temp, 4);lcd_string(" mA/c",5);
		lcd_gotoxy(0, 1);                           //      
		lcd_string("S MAX=",6);lcd_num_to_str(shst, 3);
	
	
		_delay_ms(250);_delay_ms(250);
		_delay_ms(250);_delay_ms(250);
		_delay_ms(250);_delay_ms(250);
		_delay_ms(250);_delay_ms(250);
		_delay_ms(250);_delay_ms(250);
		
	start();
	
	while(1)  //     
	{
		svet:							
			if (adc_counter > 500)
		{
		
		//      
		//   1/2       , 100/196     
		voltage = (voltage_value/adc_counter) * 100/U_kof;  
		
		//       .
		//    5.1  ( )   \   1 
		current = (current_value/adc_counter) *I_kof/500;
		
		Tip_Ak();			//   
		
		adc_counter = 0; //    
		voltage_value = 0; //    
		current_value = 0; //    
				
		lcd_gotoxy(6, 0);
		lcd_num_to_str(voltage/100, 1);  //     LCD
		lcd_gotoxy(8, 0);
		lcd_num_to_str(voltage, 2);
		
		
		}	
   _delay_ms(50); 
   //***************************************************
									
												
											
											if (((PINB &(1<<PB4))==0 )&&(flag==0))  //     +      
												{U_kof++;_delay_ms(100);	}
													
											if (((PINB &(1<<PB4))==0 )&&(flag==1)) //     +   
											{I_kof++;_delay_ms(100);	}
					
											if (((PINB &(1<<PB5))==0 )&&(flag==0))  //     -      
												{U_kof--;_delay_ms(100);	}
													
											if (((PINB &(1<<PB5))==0 )&&(flag==1))  //     -   
											{I_kof--;_delay_ms(100);	}
					
		if ((PINB &(1<<PB0))==0 )  //     ..
				{	if ((PINC &(1<<PC3))==0 ){PORTC |=(1<<PC3); _delay_ms(500);_delay_ms(500);goto svet; } //  
					
			 
							while((PINB &(1<<PB0))==0 ) //     (PB0) 
								{ k++;
									_delay_ms(18);
									if (k>150	) //      ~ 2 
									{flag=flag_zar=min=k=clock=t=emkost=0;
										save (); _delay_ms(500);start();_delay_ms(500) ;   //   
										goto svet;}

								}
			
					PORTC |=(1<<PC4); flag=1;//   1   Pc4 ,   
					PORTB &= ~(1<<PB1); shima=0;
					flag_zar=0;//    ,  
			
				}
		
		if (((PINC &(1<<PC2))==0)&&(Uoff==290))  //     ..
				{	if ((PINC &(1<<PC3))==0 ){PORTC |=(1<<PC3); _delay_ms(100);_delay_ms(500);goto svet; }//  
					
							while((PINC &(1<<PC2))==0 ) //     (PC2) zaryad
							{ k++;
											_delay_ms(18);
											if (k>150	) //         ~ 2 
											{k=0;shima_set();
												flag=flag_zar=min=clock=t=emkost=0;
												_delay_ms(500);start();_delay_ms(500) ;
											  
											goto svet;}

							}
							
							
							
					flag_zar=1;
					
					PORTC &= ~(1<<PC4); //     
					flag=0; //  
			
				}
		//    ==========     ========							
		 if ((voltage < Uoff)&&(flag==1))   //    1 (2,80 Li-ion)   
				 {
					 PORTC &= ~(1<<PC4);  //   ,
					 flag=0;
					 eeprom_write_word(&eeprom_emcost,emkost/60);
					 if ((Uoff==290)&&(flag_zar==0))  //   (2,80 Li-ion)     LI-ion 
					 {	
						 flag_zar=1;
						 _delay_ms(100);
						 min=0 ;
						 clock=0 ;
						 t=0;
					 }
				 }
		 
		 //    ==========      ========
		 if ((flag==1)||(flag_zar==1))						//   
				{
				 LCD_Time();
				 if (flag_zar==1)
									 {lcd_gotoxy(11, 0);lcd_string("S.",2);lcd_num_to_str(shima, 3);
															 lcd_gotoxy(10, 0);
															 if (j<6)
															 {lcd_dat(j);j++;_delay_ms(100);} //     
															 else
															 {j=0; }
				 
				 
									 }
				 if (flag==1)    // 
									{
				 
				 
										lcd_gotoxy(10, 0); //     
										if (j<=0)
										{lcd_dat(j);j=5;_delay_ms(100);}
										else
										{lcd_dat(j);_delay_ms(100);j--; }
										lcd_string("A.",2);lcd_num_to_str(current, 3); // 
									}
				 }
		//   
		else {   lcd_gotoxy(11, 0);lcd_string("_STOP",5);  }	
						
			ZAR_REG ();	
																							lcd_gotoxy(0, 2);
																							lcd_num_to_str(U_kof, 3);
																							lcd_gotoxy(5, 2);
																							lcd_num_to_str(I_kof, 3);							
								
	}
	
}